package space.blokk

enum class CoordinatePart {
    X,
    Y,
    Z
}

data class CoordinatePartOrder(val first: CoordinatePart, val second: CoordinatePart, val third: CoordinatePart) {
    init {
        val values = arrayOf(first, second, third)
        if (values.distinct().size != values.size)
            throw IllegalArgumentException("first, second and third must have different values")
    }

    companion object {
        val DEFAULT = CoordinatePartOrder(
            CoordinatePart.X,
            CoordinatePart.Y,
            CoordinatePart.Z
        )
    }
}
