package space.blokk.entity

import space.blokk.event.Event
import space.blokk.event.EventBus
import space.blokk.logging.Logger
import java.util.*
import kotlin.reflect.KClass

abstract class Entity internal constructor() {
    val uuid: UUID = UUID.randomUUID()

    companion object {
        internal inline fun <reified T : Entity> type(
            numericID: Int,
            id: String,
            width: Float,
            height: Float
        ) : EntityType<T> = object : EntityType<T> {
            override val entityClass: KClass<T> = T::class
            override val numericID: Int = numericID
            override val id: String = id
            override val width: Float = width
            override val height: Float = height
        }
    }
}
