plugins {
    kotlin("jvm")
}

group = rootProject.group
version = rootProject.version

repositories {
    mavenCentral()
    jcenter()
}

val nettyVersion = properties["version.netty"].toString()
val junitVersion = properties["version.junit"].toString()
val striktVersion = properties["version.strikt"].toString()
val guavaVersion = properties["version.guava"].toString()

dependencies {
    api(project(":blokk-packets"))
    api(project(":blokk-nbt"))

    // Netty
    api("io.netty:netty-buffer:${nettyVersion}")

    // Other
    api("com.google.guava:guava:$guavaVersion")

    // Testing
    testImplementation("io.strikt:strikt-core:${striktVersion}")
    testImplementation("org.junit.jupiter:junit-jupiter-api:${junitVersion}")
    testRuntimeOnly("org.junit.jupiter:junit-jupiter-engine:${junitVersion}")
}

tasks {
    compileKotlin {
        kotlinOptions.freeCompilerArgs = listOf(
            "-Xopt-in=kotlin.RequiresOptIn"
        )
    }

    test {
        useJUnitPlatform()
    }
}
