package space.blokk.net.packet.handshaking

import io.netty.buffer.ByteBuf
import space.blokk.net.MinecraftProtocolDataTypes.readString
import space.blokk.net.MinecraftProtocolDataTypes.readVarInt
import space.blokk.net.packet.IncomingPacketCodec

object HandshakePacketCodec : IncomingPacketCodec<HandshakePacket>(0x00, HandshakePacket::class) {
    override fun decode(msg: ByteBuf): HandshakePacket = HandshakePacket(
        protocolVersion = msg.readVarInt(),
        serverAddress = msg.readString(),
        serverPort = msg.readUnsignedShort(),
        loginAttempt = msg.readVarInt() == 2
    )
}
