package space.blokk.net.packet.login

import io.netty.buffer.ByteBuf
import space.blokk.net.MinecraftProtocolDataTypes.readVarInt
import space.blokk.net.packet.IncomingPacketCodec

object EncryptionResponsePacketCodec :
    IncomingPacketCodec<EncryptionResponsePacket>(0x01, EncryptionResponsePacket::class) {
    override fun decode(msg: ByteBuf): EncryptionResponsePacket {
        val sharedSecretLength = msg.readVarInt()
        val sharedSecret = ByteArray(sharedSecretLength)
        msg.readBytes(sharedSecret)

        val verifyTokenLength = msg.readVarInt()
        val verifyToken = ByteArray(verifyTokenLength)
        msg.readBytes(verifyToken)

        return EncryptionResponsePacket(sharedSecret, verifyToken)
    }
}
