package space.blokk.net.packet.login

import io.netty.buffer.ByteBuf
import space.blokk.net.MinecraftProtocolDataTypes.readVarInt
import space.blokk.net.packet.IncomingPacketCodec

object LoginPluginResponsePacketCodec :
    IncomingPacketCodec<LoginPluginResponsePacket>(0x02, LoginPluginResponsePacket::class) {
    override fun decode(msg: ByteBuf): LoginPluginResponsePacket {
        val messageID = msg.readVarInt()
        val successful = msg.readBoolean()
        val data =
            if (successful) ByteArray(msg.readableBytes()).also { msg.readBytes(it) }
            else null

        return LoginPluginResponsePacket(messageID, data)
    }
}
