package space.blokk.net.packet.play

import io.netty.buffer.ByteBuf
import space.blokk.net.MinecraftProtocolDataTypes.writeVarInt
import space.blokk.net.packet.OutgoingPacketCodec
import space.blokk.util.bitmask
import space.blokk.util.setBit

object PlayerPositionAndLookPacketCodec :
    OutgoingPacketCodec<PlayerPositionAndLookPacket>(0x34, PlayerPositionAndLookPacket::class) {
    override fun PlayerPositionAndLookPacket.encode(dst: ByteBuf) {
        dst.writeDouble(locationWithRotation.x)
        dst.writeDouble(locationWithRotation.y)
        dst.writeDouble(locationWithRotation.z)
        dst.writeFloat(locationWithRotation.yaw)
        dst.writeFloat(locationWithRotation.pitch)
        dst.writeByte(bitmask(relativeX, relativeY, relativeZ, relativeYaw, relativePitch))
        dst.writeVarInt(0) // Teleport ID, I am not sure why this is needed
    }
}
