package space.blokk.net.packet.status

import io.netty.buffer.ByteBuf
import space.blokk.net.MinecraftProtocolDataTypes.writeString
import space.blokk.net.packet.OutgoingPacketCodec
import space.blokk.util.moshi
import space.blokk.util.toJson

object ResponsePacketCodec : OutgoingPacketCodec<ResponsePacket>(0x00, ResponsePacket::class) {
    override fun ResponsePacket.encode(dst: ByteBuf) {
        response.apply {
            dst.writeString(
                moshi.toJson(mapOf(
                    "version" to mapOf(
                        "name" to versionName,
                        "protocol" to protocolVersion
                    ),
                    "players" to mapOf(
                        "max" to maxPlayers,
                        "online" to onlinePlayers,
                        "sample" to playerListSample
                    ),
                    "description" to description,
                    "favicon" to favicon?.let { "data:image/png;base64,$it" }
                )))
        }
    }
}
