package space.blokk.net.packet.status

import space.blokk.chat.LegacyFormattingCode
import space.blokk.chat.TextComponent
import space.blokk.net.ServerListInfo
import space.blokk.net.packet.OutgoingPacket

/**
 * Sent by the server in response to a [RequestPacket][space.blokk.net.packet.status].
 *
 * @param versionName The name of the Minecraft version the server uses.
 * @param protocolVersion The number of the [protocol version](https://wiki.vg/Protocol_version_numbers) used by the server.
 * @param description The description of the server. Although this is a [TextComponent], [LegacyFormattingCode]s must be used.
 * @param players The players shown when hovering over the player count.
 * @param favicon The favicon of the server. This must be a base64 encoded 64x64 PNG image.
 */
data class ResponsePacket(
    val response: ServerListInfo
) : OutgoingPacket()
