package space.blokk.net

import io.netty.channel.*
import io.netty.handler.timeout.IdleStateHandler
import space.blokk.BlokkServer

class BlokkChannelInitializer(private val server: BlokkServer) : ChannelInitializer<Channel>() {
    override fun initChannel(channel: Channel) {
        if (!ipTOSFailed) try {
            channel.config().setOption(ChannelOption.IP_TOS, 0x18)
        } catch (e: ChannelException) {
            ipTOSFailed = true
            server.logger warn "Your OS does not support IP type of service"
        }

        channel.pipeline().addLast("framing", FramingCodec(server))
    }

    companion object {
        private var ipTOSFailed = false
    }
}
