package space.blokk.net.packet.login

import space.blokk.net.BlokkSession
import space.blokk.net.PacketReceivedEventHandler

object EncryptionResponsePacketHandler : PacketReceivedEventHandler<EncryptionResponsePacket>() {
    override suspend fun handle(session: BlokkSession, packet: EncryptionResponsePacket) {
        try {
            session.joinProcedure.onEncryptionResponse(packet)
        } catch (e: IllegalStateException) {
            session.failBecauseOfClient("Client sent EncryptionResponsePacket when it was not allowed.")
        }
    }
}
