package space.blokk.net.packet.play

import space.blokk.net.BlokkSession
import space.blokk.net.PacketReceivedEventHandler
import space.blokk.player.BlokkPlayer
import space.blokk.player.event.PlayerSettingsUpdateEvent

object ClientSettingsPacketHandler : PacketReceivedEventHandler<ClientSettingsPacket>() {
    override suspend fun handle(session: BlokkSession, packet: ClientSettingsPacket) {
        val player = session.player

        if (player == null) {
            try {
                session.joinProcedure.onClientSettingsReceived(packet)
            } catch (e: IllegalStateException) {
                session.failBecauseOfClient("Client sent ClientSettingsPacket when it was not allowed")
            }
        } else {
            (player as BlokkPlayer).settings =
                session.server.eventBus.emit(PlayerSettingsUpdateEvent(player, packet.asPlayerSettings())).settings
        }
    }
}
