package space.blokk.net.packet.play

import space.blokk.net.BlokkSession
import space.blokk.net.PacketReceivedEventHandler

object IncomingKeepAlivePacketHandler : PacketReceivedEventHandler<IncomingKeepAlivePacket>() {
    override suspend fun handle(session: BlokkSession, packet: IncomingKeepAlivePacket) {
        if (session.lastKeepAlivePacketTimestamp == packet.id) {
            session.ping = (System.currentTimeMillis() - session.lastKeepAlivePacketTimestamp).toInt()
            session.keepAliveDisconnectJob.cancel()
            session.scheduleKeepAlivePacket()
        } else {
            session.disconnect(internalReason = "The ID of the last IncomingKeepAlive packet does not match the expected one.")
        }
    }
}
