package space.blokk.net.packet.status

import space.blokk.net.PacketReceivedEventHandler
import space.blokk.net.ProtocolPacketReceivedEventHandler
import space.blokk.net.event.ServerListInfoRequestEvent

object StatusProtocolHandler : ProtocolPacketReceivedEventHandler(mapOf(
    RequestPacket::class to PacketReceivedEventHandler.of<RequestPacket> { session, _ ->
        val event = session.server.eventBus.emit(ServerListInfoRequestEvent(session))
        val response = event.response

        when {
            event.cancelled -> session.disconnect(internalReason = "The ServerListInfoRequestEvent was cancelled.")
            response == null ->
                session.disconnect(internalReason = "The response property of the ServerListInfoRequestEvent is null.")

            else -> session.send(ResponsePacket(response))
        }
    },
    PingPacket::class to PacketReceivedEventHandler.of<PingPacket> { session, packet ->
        session.send(PongPacket(packet.payload))
        session.disconnect()
    }
))
