plugins {
    `java-gradle-plugin`
    kotlin("jvm") version "1.4.20"
}

repositories {
    mavenCentral()
}

dependencies {
    implementation("org.jetbrains.kotlin:kotlin-reflect:1.4.20")

    implementation("com.squareup.okhttp3:okhttp:4.9.0")
    implementation("com.jsoniter:jsoniter:0.9.23")
    implementation("com.squareup:kotlinpoet:1.7.2")
    implementation("com.google.guava:guava:30.0-jre")
}

tasks {
    compileKotlin {
        kotlinOptions.freeCompilerArgs = listOf(
            "-Xopt-in=kotlin.time.ExperimentalTime",
            "-progressive"
        )
    }
}

gradlePlugin {
    plugins {
        create("minecraft-data-sources") {
            id = "minecraft-data-sources"
            implementationClass = "space.blokk.mdsp.MinecraftDataSourcesPlugin"
        }
    }
}
