package space.blokk.testplugin.anvil

import space.blokk.world.Chunk
import space.blokk.world.Voxel
import space.blokk.world.VoxelLocation
import space.blokk.world.block.Block

class AnvilVoxel(
    override val location: VoxelLocation,
    override val world: AnvilWorld
) : Voxel() {
    private val chunkX: Int
    private val chunkY: UByte = location.y
    private val chunkZ: Int

    init {
        val (x, z) = chunk.key.translateWorldToChunk(location.x, location.z)
        chunkX = x
        chunkZ = z
    }

    private val sectionIndex = chunkY.toInt() / Chunk.SECTION_HEIGHT
    private val index = chunkY.toInt() * Chunk.AREA + chunkZ * Chunk.LENGTH + chunkX

    override var block: Block
        get() = (chunk as AnvilChunk).sections[sectionIndex].blocks[index]
        set(value) {
            (chunk as AnvilChunk).sections[sectionIndex].blocks[index] = value
        }
}
